
;Dialog Window With Subclassed Static Control - DednDave, 4-2012

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST
        INCLUDE    DlgSubStatic.inc

;###############################################################################################

        .DATA

testdata db 'test'

;***********************************************************************************************

        .DATA?
        ALIGN   4

hInstance       HINSTANCE ?
hDlg            HWND ?
hIcon           HANDLE ?
lpfnStc         LPVOID ?
hBrush          HANDLE ?
dwStaticFlags   dd ?

hStatic1        HWND ?
hStatic2        HWND ?
hStatic3        HWND ?
hStatic4        HWND ?
hStatic5        HWND ?

;###############################################################################################

        .CODE

;***********************************************************************************************

DlgProc PROC    hWndDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     eax,uMsg

        .if eax==WM_CTLCOLORSTATIC
            INVOKE  SelectObject,lParam,hBrush
            mov     eax,hBrush
            jmp     DlgPrZ

        .elseif eax==WM_ACTIVATE
            movzx   eax,word ptr wParam
            .if !eax
                mov     dwStaticFlags,eax
            .endif

        .elseif eax==WM_INITDIALOG

            ;intialize the global dialog window handle

            push    ebx
            push    esi
            push    edi
            mov     ebx,hWndDlg
            mov     hDlg,ebx

            ;load the icon from resource and set to caption bar

            INVOKE  LoadIcon,hInstance,IDI_ICON
            mov     hIcon,eax
            INVOKE  SendMessage,ebx,WM_SETICON,ICON_BIG,eax

            ;create a brush for the static controls

            INVOKE  CreateSolidBrush,0FFh      ;red
            mov     hBrush,eax

            ;subclass the static controls

            mov     esi,IDC_STATIC1
            mov     edi,offset hStatic1
            .while esi<=IDC_STATIC5
                INVOKE  GetDlgItem,hWndDlg,esi
                stosd
                mov     ebx,eax
                .if esi==IDC_STATIC1
                    INVOKE  GetWindowLong,eax,GWL_WNDPROC
                    mov     lpfnStc,eax
                .endif
            INVOKE  SetWindowLong,ebx,GWL_USERDATA,esi
            INVOKE  SetWindowLong,ebx,GWL_WNDPROC,StcProc
            inc     esi
            .endw
            pop     edi
            pop     esi
            pop     ebx

        .elseif eax==WM_CLOSE

            ;restore the original WndProc's

            push    esi
            mov     esi,offset hStatic1
            .while esi<=offset hStatic5
                lodsd
                INVOKE  SetWindowLong,eax,GWL_WNDPROC,lpfnStc
            .endw
            pop     esi

            ;delete the static control brush

            INVOKE  DeleteObject,hBrush

            ;destroy the dialog window

            INVOKE  EndDialog,hWndDlg,NULL

        .else

            ;return FALSE

            xor     eax,eax
            jmp     DlgPrZ

        .endif

;return TRUE

        mov     eax,TRUE

;return EAX

DlgPrZ: ret

DlgProc ENDP

;***********************************************************************************************

StcProc PROC  hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     eax,uMsg
        .if eax==WM_MOUSEMOVE
            INVOKE  GetForegroundWindow
                .if eax==hDlg
                INVOKE  GetWindowLong,hWnd,GWL_USERDATA
                mov     ecx,eax
                sub     ecx,IDC_STATIC1
                mov     edx,1
                shl     edx,cl
                test    edx,dwStaticFlags
                jnz     StcPrZ

                push    eax
                xchg    edx,dwStaticFlags
                INVOKE  ShowWindow,hWnd,SW_HIDE
                xor     edx,edx
                pop     eax
                INVOKE  CreateThread,edx,edx,MmThrd,eax,edx,edx
                jmp     StcPrZ
                .endif
        .endif

;return via original (system) WndProc

StcPrX: INVOKE  CallWindowProc,lpfnStc,hWnd,uMsg,wParam,lParam

;return EAX

StcPrY: ret

;return FALSE

StcPrZ: xor     eax,eax
        jmp     StcPrY

StcProc ENDP

;***********************************************************************************************

MmThrd  PROC

        mov     ebp,esp                      ;EBP = stack frame
        mov     edi,[ebp+4]                  ;EDI = Child ID
        INVOKE  GetDlgItem,hDlg,edi
        mov     ebx,eax                      ;EBX = hChild
        mov     ecx,edi
        sub     ecx,IDC_STATIC1
        mov     esi,1
        shl     esi,cl                       ;ESI = flag bit

MThrd0: INVOKE  Sleep,40
        test    esi,dwStaticFlags
        jz      MThrd2

        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,ebx,esp
        lea     edx,[esp+8]
        INVOKE  ClientToScreen,hDlg,edx
        INVOKE  ClientToScreen,hDlg,esp
        push    edx
        push    ecx
        INVOKE  GetCursorPos,esp
        pop     ecx
        pop     edx
        pop     eax
        cmp     eax,ecx
        ja      MThrd1

        pop     eax
        cmp     eax,ecx
        jbe     MThrd1

        pop     eax
        cmp     eax,edx
        ja      MThrd1

        pop     eax
        cmp     eax,edx
        ja      MThrd0

MThrd1: xchg    eax,dwStaticFlags
        not     esi
        and     eax,esi
        xchg    eax,dwStaticFlags

MThrd2: INVOKE  ShowWindowAsync,ebx,SW_SHOW
        mov     esp,ebp
        INVOKE  ExitThread,0

MmThrd  ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        xor     edi,edi                                 ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     edx

;------------------------------

;create dialog box

        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  DialogBoxParam,eax,IDW_DLG,edi,DlgProc,edi

;------------------------------

;exit program

        INVOKE  ExitProcess,eax

;------------------------------

_main   ENDP

;###############################################################################################

        END     _main

